﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Custom View class 
'Version 1.1
#Event: Selection (LevelList As Int)
#RaisesSynchronousEvents: Selection
#DesignerProperty: Key: ValueMinX, DisplayName: ValueMinX, FieldType: Int, DefaultValue: 0, Description: Value min x axis.
#DesignerProperty: Key: ValueMaxX, DisplayName: ValueMaxX, FieldType: Int, DefaultValue: 24, Description: Value max x axis.
#DesignerProperty: Key: ValueMinY, DisplayName: ValueMinY, FieldType: Int, DefaultValue: 0, Description: Value min y axis.
#DesignerProperty: Key: ValueMaxY, DisplayName: ValueMaxY, FieldType: Int, DefaultValue: 100, Description: Value max y axis.

Sub Class_Globals
	Type LevelPoint(X As Double, Y As Double)
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private pnlMain, pnlLevels, pnlGraph, pnlEdit As Panel
	Private cvsMain, cvsLevels, cvsGraph As Canvas
	Private mParent As Panel
	Private rctMain, rctGraph As Rect
	Private lstLevels As List
	Private btnBack, btnSelectPoint, btnDeletePoint, btnAdjustPoint As Button
	Private lblXValue, lblYValue As Label
	Private btnEditCancel, btnEditOK As Button
	Private lblEditXValue, lblEditYValue, lblError As Label
	Private edtEditXValue, edtEditYValue As EditText
	
	Private mLevelColor, mCursorColor As Int
	
	Private CurrentIndex, PrevIndex, NextIndex As Int
	Private SelectedPointX, SelectedPointY As Int
	Private PrevX, PrevY, NextX, NextY As Int
	Private mLeft, mTop, mWidth, mHeight As Int
	Private mValueMinX, mValueMaxX, mValueMinY, mValueMaxY As Double
	
	Private GraphX0, GraphX1, GraphW, GraphY0, GraphY1, GraphH As Int
	Private GraphScaleX, GraphScaleY As Double
	Private CursorX, CursorY, CursorMin, CursorMax  As Int
	Private CursorValX, CursorValY, CursorDX, CursorDY As Double
	Private NewPoint, SelectPoint, MovePoint As Boolean
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mParent = Base.Parent
	mLeft = Base.Left
	mTop = Base.Top
	mWidth = Base.Width
	mHeight = Base.Height

	pnlMain.Initialize("pnlMain")
	mParent.AddView(pnlMain, mLeft, mTop, mWidth, mHeight)
  
	Base.RemoveView
	
	Init
End Sub

'Adds the SetLevels onto the parent view
'Parent = parent view, can be either an Activity or a Panel
'Left, Top = position of the view
'Width, Height = dimensions of the view
Public Sub AddToParent(Parent As Panel, Left As Int, Top As Int, Width As Int, Height As Int)
	mParent = Parent
	mLeft = Left
	mTop = Top
	mWidth = Width
	mHeight = Height
	
	pnlMain.Initialize("pnlMain")
	mParent.AddView(pnlMain, mLeft, mTop, mWidth, mHeight)
	
	Init
End Sub

Private Sub Init
	pnlLevels.Initialize("pnlLevels")
	pnlMain.AddView(pnlLevels, 0, 0, mWidth, mHeight)
	
	pnlGraph.Initialize("pnlGraph")
	pnlMain.AddView(pnlGraph, 0, 0, mWidth, mHeight)
	
	Private btnLeft, btnTop, btnWidth1, btnWidth2, btnHeight, btnSpace, lblTop, lblWidth As Int
	
	btnWidth1 = 85dip
	btnWidth2 = 70dip	
	btnSpace = Min((mWidth- btnWidth1 - 3 * btnWidth2) / 5, 20dip)
	btnLeft = btnSpace
	btnTop = mHeight - 45dip
	btnHeight = 40dip
	btnSelectPoint.Initialize("btnSelectPoint")
	pnlMain.AddView(btnSelectPoint, btnLeft, btnTop, btnWidth1, btnHeight)
	btnSelectPoint.Text = "Selection"
	btnSelectPoint.TextColor = Colors.Red
	
	btnDeletePoint.Initialize("btnDeletePoint")
	pnlMain.AddView(btnDeletePoint, btnSelectPoint.Left + btnSelectPoint.Width + btnSpace, btnTop, btnWidth2, btnHeight)
	btnDeletePoint.Text = "Delete"
	btnDeletePoint.Visible = False

	btnAdjustPoint.Initialize("btnAdjustPoint")
	pnlMain.AddView(btnAdjustPoint, btnDeletePoint.Left + btnDeletePoint.Width + btnSpace, btnTop, btnWidth2, btnHeight)
	btnAdjustPoint.Text = "Adjust"
	btnAdjustPoint.Visible = False
	
	btnBack.Initialize("btnBack")
	pnlMain.AddView(btnBack, btnAdjustPoint.Left + btnAdjustPoint.Width + btnSpace, btnTop, btnWidth2, btnHeight)
	btnBack.Text = "Back"
	
	lblXValue.Initialize("lblXValue")
	pnlMain.AddView(lblXValue, mWidth / 2 - 105dip, 0, 100dip, 30dip)
	lblXValue.TextColor = Colors.Black
	
	lblYValue.Initialize("lblYValue")
	pnlMain.AddView(lblYValue, mWidth / 2 + 5dip, 0, 100dip, 30dip)
	lblYValue.TextColor = Colors.Black
	
	pnlEdit.Initialize("pnlEdit")
	pnlMain.AddView(pnlEdit, 0, 0, mWidth, mHeight)
	pnlEdit.Color = Colors.ARGB(240, 255, 255, 255)
	pnlEdit.Visible = False
	
	btnEditOK.Initialize("btnEditOK")
	pnlEdit.AddView(btnEditOK, mWidth / 2 - btnWidth1 - btnSpace, btnTop, btnWidth1, btnHeight)
	btnEditOK.Text = "O K"

	btnEditCancel.Initialize("btnEditCancel")
	pnlEdit.AddView(btnEditCancel, mWidth / 2 + btnSpace, btnTop, btnWidth1, btnHeight)
	btnEditCancel.Text = "Cancel"
	
	lblWidth = 120dip
	lblTop = btnTop - btnHeight - btnSpace / 2
	edtEditXValue.Initialize("edtEditXValue")
	pnlEdit.AddView(edtEditXValue, mWidth / 2 - lblWidth - btnSpace, lblTop, lblWidth, btnHeight)
	edtEditXValue.InputType = edtEditXValue.INPUT_TYPE_DECIMAL_NUMBERS
	edtEditXValue.TextColor = Colors.Black
	edtEditXValue.Gravity = Gravity.CENTER

	edtEditYValue.Initialize("edtEditYValue")
	pnlEdit.AddView(edtEditYValue, mWidth / 2 + btnSpace, lblTop, lblWidth, btnHeight)
	edtEditYValue.InputType = edtEditYValue.INPUT_TYPE_DECIMAL_NUMBERS
	edtEditYValue.TextColor = Colors.Black
	edtEditYValue.Gravity = Gravity.CENTER
	
	lblTop = edtEditXValue.Top - btnHeight - btnSpace / 2
	lblEditXValue.Initialize("lblEditXValue")
	pnlEdit.AddView(lblEditXValue, mWidth / 2 - lblWidth - btnSpace, lblTop, lblWidth, btnHeight)
	lblEditXValue.TextSize = 18
	lblEditXValue.TextColor = Colors.Black
	lblEditXValue.Gravity = Gravity.CENTER
	lblEditXValue.Text = "X value"

	lblEditYValue.Initialize("btnEditCancel")
	pnlEdit.AddView(lblEditYValue, mWidth / 2 + btnSpace, lblTop, lblWidth, btnHeight)
	lblEditYValue.TextSize = 18
	lblEditYValue.TextColor = Colors.Black
	lblEditYValue.Gravity = Gravity.CENTER
	lblEditYValue.Text = "Y value"
	
	lblWidth = 300dip
	lblError.Initialize("lblError")
	pnlEdit.AddView(lblError, (mWidth - lblWidth) / 2, btnSpace / 2, lblWidth, mHeight - lblTop - btnSpace)
	lblError.Color = Colors.RGB(245, 245, 245)
	lblError.TextColor = Colors.Black
	lblError.Gravity = Gravity.BOTTOM
	lblError.Visible = False
	
	cvsMain.Initialize(pnlMain)
	cvsLevels.Initialize(pnlLevels)
	cvsGraph.Initialize(pnlGraph)

	mValueMinX = 0
	mValueMaxX = 24
	mValueMinY = 0
	mValueMaxY = 100
	
	InitLevels
	InitGraph
End Sub

'Initializes the variables for the levels
Private Sub InitLevels
	lstLevels.Initialize

	Private pnt As LevelPoint
	pnt.X = mValueMinX
	pnt.Y = (mValueMaxY - mValueMinY) / 2
	lstLevels.Add(pnt)

	Private pnt As LevelPoint
	pnt.X = mValueMaxX
	pnt.Y = (mValueMaxY - mValueMinY) / 2
	lstLevels.Add(pnt)
	
	PrevIndex = 0
	NextIndex = 1
End Sub

'Initializes the variables for the graphics
Private Sub InitGraph
	mLevelColor = Colors.Red
	mCursorColor = Colors.Blue

	GraphX0 = 40dip
	GraphX1 = mWidth - 20dip
	GraphW = GraphX1 - GraphX0
	
	GraphY0 = 20dip
	GraphY1 = mHeight - 65dip
	GraphH = GraphY1 - GraphY0
	
	rctMain.Initialize(0, 0, pnlMain.Width, pnlMain.Height)
	rctGraph.Initialize(GraphX0, GraphY0, GraphX1, GraphY1)
	
	cvsLevels.DrawColor(Colors.Transparent)
	
	GraphScaleX = GraphW / (mValueMaxX - mValueMinX)
	GraphScaleY = GraphH / (mValueMinY - mValueMaxY)
	CursorDX = 20dip / GraphScaleX
	CursorDY = -20dip / GraphScaleY
	
	pnlMain.Visible = False
End Sub

'Shows the the SetLevels CustomView
'LevelList = List of level points or Null
'Null sets two points at min X value and max X value and half the max level height
Public Sub Show(LevelList As List)
	Private OK As Boolean
	
	If LevelList.IsInitialized = True Then
		OK = CheckList(LevelList)
		If OK = True Then
			lstLevels = LevelList			
		Else
			ToastMessageShow("Wrong data !", False)
			Return
		End If
	End If
	
	pnlMain.Visible = True
	DrawDiagram
End Sub

Private Sub pnlMain_Touch (Action As Int, X As Float, Y As Float)
	Private pntPrev, pntNext, pntCurrent As LevelPoint
	
	If SelectPoint Then
		'Point selection mode active
		Select Action
			Case 0	'DOWN
				CursorX = Min(X, GraphW + GraphX0)
				CursorX = Max(GraphX0, CursorX)
				CursorY = Min(Y, GraphH + GraphY0)
				CursorY = Max(GraphY0, CursorY)
				CursorValX = (CursorX - GraphX0) / GraphScaleX
				CursorValY = (CursorY - GraphY1) / GraphScaleY
				GetPoint
				DrawSelectedPoint
				If CurrentIndex >= 0 Then
					btnAdjustPoint.Visible = True
					If CurrentIndex > 0 And CurrentIndex < lstLevels.Size - 1 Then
						btnDeletePoint.Visible = True
					Else
						btnDeletePoint.Visible = False
						'	SelectPoint = False
					End If
				Else
					btnAdjustPoint.Visible = False
					btnDeletePoint.Visible = False
				End If
		End Select
	Else
		'Point moving mode active
		Select Action
			Case 0	'DOWN
				CursorX = Min(X, GraphW + GraphX0)
				CursorX = Max(GraphX0, CursorX)
				CursorY = Min(Y, GraphH + GraphY0)
				CursorY = Max(GraphY0, CursorY)
				CursorValX = (CursorX - GraphX0) / GraphScaleX
				CursorValY = (CursorY - GraphY1) / GraphScaleY
				GetPrevNextIndex
				pntPrev = lstLevels.Get(PrevIndex)
				pntNext = lstLevels.Get(NextIndex)
				PrevX = GraphX0 + pntPrev.X * GraphScaleX
				PrevY = GraphY1 + pntPrev.Y * GraphScaleY
				NextX = GraphX0 + pntNext.X * GraphScaleX
				NextY = GraphY1 + pntNext.Y * GraphScaleY
				CursorMin = PrevX
				CursorMax = NextX
				If NewPoint = False And MovePoint = False Then
					pntCurrent = lstLevels.Get(CurrentIndex)
					CursorX = GraphX0 + pntCurrent.X * GraphScaleX
				End If
				lblXValue.Text = "x = " & NumberFormat2(CursorValX, 1, 2, 0, False)
				lblYValue.Text = "y = " & NumberFormat2(CursorValY, 1, 2, 0, False)
			Case 1	'UP
				Private Answ As Int
				Private Message As String
				If NewPoint Then
					Message = "Confirm new point?"
				Else
					Message = "Confirm new level?"
				End If
				Answ = Msgbox2(Message, "Confirm", "Yes", "", "No", Null)
				If Answ = DialogResponse.POSITIVE Then
					If NewPoint Then
						pntNext.X = CursorValX
						pntNext.Y = CursorValY
						lstLevels.InsertAt(NextIndex, pntNext)
						If lstLevels.Size <= 2 Then
							btnDeletePoint.Visible = False
							btnAdjustPoint.Visible = False
						End If
					Else
						pntCurrent.X = CursorValX
						pntCurrent.Y = CursorValY
						lstLevels.Set(CurrentIndex, pntCurrent)
					End If
					DrawDiagram
				End If
				cvsLevels.DrawColor(Colors.Transparent)
				pnlLevels.Invalidate
				lblXValue.Text = ""
				lblYValue.Text = ""
			Case 2	'MOVE
				cvsLevels.DrawLine(PrevX, PrevY, CursorX, CursorY, Colors.Transparent, 2dip)
				cvsLevels.DrawLine(CursorX, CursorY, NextX, NextY, Colors.Transparent, 2dip)
				cvsLevels.DrawCircle(CursorX, CursorY, 5dip, Colors.Transparent, True, 1dip)
				CursorX = Max(CursorMin, X)
				CursorX = Min(CursorMax, CursorX)
				CursorY = Min(GraphY1, Y)
				CursorY = Max(CursorY, GraphY0)
				If NewPoint = False And MovePoint = False Then
					pntCurrent = lstLevels.Get(CurrentIndex)
					CursorX = GraphX0 + pntCurrent.X * GraphScaleX
				End If
				cvsLevels.DrawLine(PrevX, PrevY, CursorX, CursorY, mCursorColor, 2dip)
				cvsLevels.DrawLine(CursorX, CursorY, NextX, NextY, mCursorColor, 2dip)
				cvsLevels.DrawCircle(CursorX, CursorY, 5dip, mCursorColor, True, 1dip)
				pnlLevels.Invalidate
				CursorValX = (CursorX - GraphX0) / GraphScaleX
				CursorValY = (CursorY - GraphY1) / GraphScaleY
				lblXValue.Text = "x = " & NumberFormat2(CursorValX, 1, 2, 0, False)
				lblYValue.Text = "y = " & NumberFormat2(CursorValY, 1, 2, 0, False)
		End Select
	End If
End Sub

Private Sub pnlEdit_Click
	' dummy routine to avoid transmission of events
End Sub

'Checks if a point exists at the current cursor position
'Retunrns the point index or -1 if no point at the cursor position
Private Sub GetPoint
	Private i As Int
	Private pnt, pntP, pntN As LevelPoint
	
	MovePoint = False
	For i = 0 To lstLevels.Size - 1
		pnt = lstLevels.Get(i)
		If CursorValX > pnt.X - CursorDX And CursorValX < pnt.X + CursorDX And CursorValY > pnt.Y - CursorDY And CursorValY < pnt.Y + CursorDY  Then
			PrevIndex = Max(i - 1, 0)
			NextIndex = Min(i + 1, lstLevels.Size - 1)
			If CurrentIndex > 0 And CurrentIndex < lstLevels.Size - 1 Then
				pntP = lstLevels.Get(PrevIndex)
				pntN = lstLevels.Get(NextIndex)
				If pnt.X = pntP.X Or pnt.X = pntN.X Then
					MovePoint = True
				End If
			End If
			CurrentIndex = i
			NewPoint = False
			Return
		End If
	Next
	CurrentIndex = -1
End Sub

'Gets the indexes of the previus and next point for selected point
Private Sub GetPrevNextIndex
	Private i As Int
	Private pnt, pnt1 As LevelPoint
	
	GetPoint
	If CurrentIndex = -1 Then
		For i = 0 To lstLevels.Size - 2
			pnt = lstLevels.Get(i)
			pnt1 = lstLevels.Get(i + 1)
			If CursorValX > pnt.X And CursorValX < pnt1.X Then
				PrevIndex = i
				NextIndex = i + 1
				NewPoint = True
				Return
			End If
		Next
	End If
End Sub

'Checks if all points in the list are coherent
'Values in between the limits and all X values ordered
Private Sub CheckList(lst As List) As Boolean
	Private i , PrevX As Int
	Private lp As LevelPoint
	Private OK = True As Boolean
	
	lp = lst.Get(0)
	
	PrevX = mValueMinX - 10
	For i = 0 To lst.Size - 1
		lp = lst.Get(i)	
		
		If i = 0 And lp.X <> mValueMinX Then
			Log("First point must have x = " & mValueMinX)
			OK = False
		End If
		
		If i = lst.Size - 1 And lp.X <> mValueMaxX Then
			Log("Last point must have x = " & mValueMaxX)
			OK = False
		End If	
		
		If lp.X < PrevX Then
			Log("X value of point " & i & " must be bigger then the previous one")
			OK = False
		End If
		
		If lp.Y < mValueMinY Then
			Log("Y value of point " & i & " too small!")
			OK = False			
		End If
		
		If lp.Y > mValueMaxY Then
			Log("Y value of point " & i & " too big!")
			OK = False			
		End If
		
		PrevX = lp.X
	Next
	
	Return OK
End Sub

'Checks the values in the EditTexts if they are in the limits
Private Sub CheckValues As Boolean
	Private OK = True As Boolean
	Private lpPrev, lpNext As LevelPoint
	Private ErrorText As String
	Private ValX, ValY As Double
	
	ErrorText = "Error:" & CRLF
	
	ValX = edtEditXValue.Text
	ValY = edtEditYValue.Text
	
	If CurrentIndex > 0  Then
		lpPrev = lstLevels.Get(CurrentIndex - 1)
	End If
	If CurrentIndex < lstLevels.Size - 1 Then
		lpNext = lstLevels.Get(CurrentIndex + 1)
	End If
	If CurrentIndex > 0 And CurrentIndex < lstLevels.Size - 1 Then
		If ValX > lpNext.X Then
			ErrorText = ErrorText & "X value too big, max value next point: " & lpNext.X & CRLF
			OK = False
		End If
	
		If ValX < lpPrev.X Then
			ErrorText = ErrorText & "X value too small, min value previous point: " & lpPrev.X & CRLF
			OK = False
		End If	
	End If
	
	If ValY > mValueMaxY Then
		ErrorText =ErrorText &  "Y value too big, max value next point: " & mValueMaxY & CRLF
		OK = False
	End If
	
	If ValY < mValueMinY Then
		ErrorText = ErrorText & "Y value too small big, min value previous point: " & mValueMinY & CRLF
		OK = False
	End If
	
	If OK = False Then
		lblError.Text = ErrorText
	End If
	
	Return OK
End Sub

'Draws the diagram
Private Sub DrawDiagram
	Private i, x0, y0, x1, y1 As Int
	Private pnt0, pnt1 As LevelPoint
	
	cvsMain.DrawColor(Colors.White)
	cvsMain.DrawRect(rctGraph, Colors.Black, False, 1dip)

	cvsMain.DrawText(mValueMinY, GraphX0 - 5dip, GraphY1 + 3dip, Typeface.DEFAULT, 12, Colors.Black, "RIGHT")
	cvsMain.DrawText(mValueMaxY, GraphX0 - 5dip, GraphY0 + 3dip, Typeface.DEFAULT, 12, Colors.Black, "RIGHT")
	
	cvsMain.DrawText(mValueMinX, GraphX0, GraphY1 + 15dip, Typeface.DEFAULT, 12, Colors.Black, "CENTER")
	cvsMain.DrawText(mValueMaxX, GraphX1, GraphY1 + 15dip, Typeface.DEFAULT, 12, Colors.Black, "CENTER")

	pnt0 = lstLevels.Get(0)
	x0 = GraphX0 + pnt0.X * GraphScaleX
	y0 = GraphY1 + pnt0.Y * GraphScaleY
	cvsMain.DrawCircle(x0, y0, 5dip, mLevelColor, True, 1dip)
	For i = 1 To lstLevels.Size - 1
		pnt1 = lstLevels.Get(i)
		x1 = GraphX0 + pnt1.X * GraphScaleX
		y1 = GraphY1 + pnt1.Y * GraphScaleY
		cvsMain.DrawLine(x0, y0, x1, y1, mLevelColor, 2dip)
		cvsMain.DrawCircle(x1, y1, 5dip, mLevelColor, True, 1dip)
		x0 = x1
		y0 = y1
	Next
	pnlMain.Invalidate
End Sub

'Erases an existing point and draws a new one if selected
Private Sub DrawSelectedPoint	
	cvsLevels.DrawCircle(SelectedPointX, SelectedPointY, 5dip, Colors.Transparent, True, 1dip)

	If CurrentIndex > -1 Then
		Private pnt As LevelPoint
		pnt = lstLevels.Get(CurrentIndex)
		SelectedPointX = GraphX0 + pnt.X * GraphScaleX
		SelectedPointY = GraphY1 + pnt.Y * GraphScaleY
		cvsLevels.DrawCircle(SelectedPointX, SelectedPointY, 5dip, Colors.Green, True, 1dip)
	End If
	pnlLevels.Invalidate
End Sub

Private Sub btnBack_Click
	pnlMain.Visible = False
	If SubExists(mCallBack, mEventName & "_Selection") Then
		CallSub2(mCallBack, mEventName & "_Selection", lstLevels)
	End If
End Sub

Private Sub btnSelectPoint_Click
	If btnSelectPoint.Text = "Selection" Then
		btnSelectPoint.Text = "Select"
		btnSelectPoint.TextColor = Colors.Green
		SelectPoint = True
	Else
		btnSelectPoint.Text = "Selection"
		btnSelectPoint.TextColor = Colors.Red
		SelectPoint = False
		CurrentIndex = -1
		DrawSelectedPoint
		btnDeletePoint.Visible = False
		btnAdjustPoint.Visible = False
	End If
End Sub

Public Sub btnAdjustPoint_Click
	Private lp As LevelPoint
	
	lp = lstLevels.Get(CurrentIndex)
	edtEditXValue.Text = NumberFormat2(lp.X, 1, 3, 0, False)	
	edtEditYValue.Text = NumberFormat2(lp.Y, 1, 3, 0, False)
	pnlEdit.Visible = True
	If CurrentIndex = 0 Or CurrentIndex = lstLevels.Size - 1 Then
		lblEditXValue.Visible = False
		edtEditXValue.Visible = False
	End If
End Sub

Public Sub btnEditCancel_Click
	pnlEdit.Visible = False
	lblError.Visible = False
End Sub

Public Sub btnEditOK_Click
	Private lp As LevelPoint
	
	If CheckValues = True Then
		lp = lstLevels.Get(CurrentIndex)
		lp.X = edtEditXValue.Text
		lp.Y = edtEditYValue.Text
		lstLevels.Set(CurrentIndex, lp)
		pnlEdit.Visible = False
		lblError.Visible = False
		
		DrawSelectedPoint
		DrawDiagram
	Else
		lblError.Visible = True
		ToastMessageShow("Values out of limit", False)
	End If
End Sub

Private Sub btnDeletePoint_Click
	Private Answ As Int
	
	Answ = Msgbox2("Do you want to delete the selected point?", "Delete", "Yes", "", "No", Null)
	
	If Answ = DialogResponse.POSITIVE Then
		lstLevels.RemoveAt(CurrentIndex)
		DrawDiagram
		CurrentIndex = -1		
		DrawSelectedPoint		
		btnDeletePoint.Visible = False
		btnAdjustPoint.Visible = False
		
		If lstLevels.Size = 2 Then
			btnSelectPoint_Click
		End If
	End If
End Sub

'Gets or sets the List of level points
Public Sub getLevelList As List
	Return lstLevels
End Sub

Public Sub setLevelList(lst As List)
	lstLevels = lst
	DrawDiagram
End Sub

'Sets the min and max value of the x axis, abscissa
Public Sub SetValuesMinMaxX(ValueMinX As Double, ValueMaxX As Double)
	mValueMinX = ValueMinX
	mValueMaxX = ValueMaxX
	InitLevels
	InitGraph
End Sub

'Sets the min and max value of the y axis, abscissa
Public Sub SetValuesMinMaxY(ValueMinY As Double, ValueMaxY As Double)
	mValueMinY = ValueMinY
	mValueMaxY = ValueMaxY
	InitLevels
	InitGraph
End Sub

